from mpi4py import MPI
import numpy as np
import matplotlib.pyplot as plt
import time
from funcs import *
from helper import *
import sys

comm = MPI.COMM_WORLD
size= comm.Get_size(); me = comm.Get_rank()
pid_main = 0
if len(sys.argv) >=2:
    np.random.seed(me*int(sys.argv[1]))
else:
    np.random.seed(me)


run_bool = True
# =========== main program for farmer-worker calculation

num_iter = 100



prey_count = np.zeros(num_iter)
pred_count = np.zeros(num_iter)
prey_sense_avg = np.zeros(num_iter)
prey_speed_avg = np.zeros(num_iter)
prey_energy_avg = np.zeros(num_iter)
pred_sense_avg = np.zeros(num_iter)
pred_speed_avg = np.zeros(num_iter)
pred_energy_avg = np.zeros(num_iter)

def init_main():    
    spawns_food = np.random.randint(low=[lim_x[0]+25,lim_y[0]+25],high=[lim_x[1]+26,lim_y[1]+26],size=(num_spawns_food,2)).astype(float)
    food = np.array([]).reshape((0,2))
    food = spawn_food(food,spawns_food,num_food)
    food_eaten = np.zeros(10)
    prey, prey_energy, prey_sense, prey_speed = init_blobs(num_prey,spawns = spawns_prey, role = 'prey')
    pred, pred_energy, pred_sense, pred_speed = init_blobs(num_pred, role = 'pred')


    start = time.time()
    return spawns_food, food,food_eaten, prey, prey_energy, prey_sense, prey_speed, pred, pred_energy, pred_sense, pred_speed, start


	
def run():
    global run_bool,start,prey,prey_energy,prey_sense,prey_speed,food,pred,pred_energy,pred_sense,pred_speed,food_eaten, gen,spawns_food
    calctime=time.time()
    if not start:
    	print('return')
    	return
    if len(prey) == 0 and num_prey != 0:
        print("extinction: prey in generation " + str(gen))
        run_bool = False
        return
    elif len(pred) == 0 and num_pred != 0:
        print("extinction: pred in generation " + str(gen))
        run_bool = False
        return
    else:
        if num_prey != 0:
            prey_count[gen] = len(prey)
            prey_sense_avg[gen] = sum(prey_sense)/len(prey_sense)
            prey_speed_avg[gen] = sum(prey_speed)/len(prey_speed)
            prey_energy_avg[gen] = sum(prey_energy)/len(prey_energy)
        if num_pred != 0:
            pred_count[gen] = len(pred)
            pred_sense_avg[gen] = sum(pred_sense)/len(pred_sense)
            pred_speed_avg[gen] = sum(pred_speed)/len(pred_speed)
            pred_energy_avg[gen] = sum(pred_energy)/len(pred_energy)    
  
    prey,prey_energy,prey_sense,prey_speed,food,pred,pred_energy,pred_sense,pred_speed,food_eaten = iter_step_main(gen,prey,prey_energy,prey_sense,prey_speed,food,pred,pred_energy,pred_sense,pred_speed,food_eaten,spawns_food)
    
    if gen >=num_iter-1:
        run_bool = False
    start=time.time()
		
if me == pid_main:
    blobs = []
    times=[]
    gen = 0
    spawns_food, food,food_eaten, prey, prey_energy, prey_sense, prey_speed, pred, pred_energy, pred_sense, pred_speed, start = init_main()
    start=time.time()
    time.sleep(0.1)
    START = time.time()
    while run_bool:
        calc = time.time()
        run()
        runs_in = time.time()-calc
        print("gen:",gen,"took:",runs_in, 'prey:' , len(prey), 'pred:', len(pred))
        blobs.append((len(prey)+len(pred)))
        times.append(runs_in)
        
        gen += 1
    final = time.time()-START
    print(final,sum(blobs),final/sum(blobs))
    
if me != pid_main:
    for i in range(num_iter):
        iter_step_worker()
        


